/* 			Copyright (c) 1988 by Caldera Corporation						*/
	
/*			PO box 3252, Ann Arbor, MI 48106   (313) 996-9059				*/

/*		File: 		Compatability.c
		Compilers: 	LightSpeedC 3.0, Aztec C 3.0							*/

/*		Abstract:															*/
/*			high level and code segment 1 routines for windowTile			*/

/*		History:															*/
/*			12/31/88 1.0c - released final 1.0 version 						*/


#ifndef	__COMPATABILITY__
#define	__COMPATABILITY__		1		/* compatability already included	*/


#define LIGHTSPEED				1		/* LightspeedC development system	*/
#ifdef LIGHTSPEED						/* if LightspeedC currently in use	*/


#ifndef RETURN		/* some compilers require "return()" in void functions	*/
#define RETURN			return
#endif


#ifndef pass		/* some compilers can't pass Point structure variables	*/
#define pass(A)			(A)
#endif


#define ptpass(A)		(A)		/* some compilers pass Point variables to 	*/
					/* by reference rather than by value Toolbox routines 	*/


#define USTRLEN(A)		((unsigned)((char*)(A)[0]))
						/* some compilers define strings as composite data 	*/
						/* structures rather than simple character arrays 	*/
#endif	

#ifdef AZTEC							/* if Aztec C is currently in use	*/
#ifndef RETURN
#define RETURN			return()
#endif

#define	ptpass(A)		(*((long*)&(A)))

#define	USTRLEN(A)		((unsigned)(*((Ptr)(&(A)))))
#endif


#ifdef MPWGC							/* if MPW C is currently in use		*/
#ifndef RETURN
#define RETURN			return
#endif

#ifndef pass
#define pass(A)			(A)
#endif

#define ptpass(A)		(&(A))

#define USTRLEN(A)		((unsigned)((A).length))

#define TRUE			((Boolean)1)
#define FALSE			((Boolean)0)
#endif


#ifndef NULL
#define NULL			0L
#endif

#endif	__COMPATABILITY__
